<html>
    <head>
        <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
    </head>
    <body>
        {% csrf_token %}
        <!-- We need verbatim so that we can add brackets for vue.js and they are ignored by django -->
        {% verbatim %}

        <div id="app" v-cloak @drop.prevent="addFile" @dragover.prevent style="border: dashed grey 2px">
            <h2>Files to Upload (Drag them over)</h2>

            <p>Then hit 'Import' to start import</p>
            <ul>
              <li v-for="file in files">
                {{ file.name }} ({{ file.size | kb }} kb) <button @click="removeFile(file)" title="Remove">X</button>
              </li>
            </ul>
            
            <button :disabled="uploadDisabled" @click="upload">Import</button>
        </div>

        {% endverbatim %}
        
        <script>

            let csrftoken = document.querySelector("input[name='csrfmiddlewaretoken']").value;

            Vue.config.productionTip = false;
            Vue.config.devtools = false;

            Vue.filter('kb', val => {
                return Math.floor(val/1024);  
            });

            const app = new Vue({
            el:'#app', 
            data: {
                files:[]
            },
            computed: {
                uploadDisabled() {
                    return this.files.length === 0;
                }
            },
            methods:{
                addFile(e) {
                    let droppedFiles = e.dataTransfer.files;
                    if(!droppedFiles) return;
                    // this tip, convert FileList to array, credit: https://www.smashingmagazine.com/2018/01/drag-drop-file-uploader-vanilla-js/
                    ([...droppedFiles]).forEach(f => {
                        this.files.push(f);
                    });
                    this.upload();
                },
                removeFile(file){
                    this.files = this.files.filter(f => {
                        return f != file;
                    });      
                },
                upload() {
                
                    let formData = new FormData();
                    this.files.forEach((f,x) => {
                        formData.append('file'+(x), f);
                    });

                    formData.append('csrfmiddlewaretoken', csrftoken);

                    let import_url = '{% url "omero_webimport_import" %}';
                    fetch(import_url, {
                        method:'POST',
                        body: formData
                    })
                    .then(res => res.json())
                    .then(res => {
                        console.log('done uploading', res);
                    })
                    .catch(e => {
                        console.error(JSON.stringify(e.message));
                    });
                }
            }
            })
        </script>
    </body>
</html>
